/*
* @Author: zhouningyi
* @Date:   2017-01-01 15:51:11
* @Last Modified by:   zhouningyi
* @Last Modified time: 2017-07-28 01:28:28
*/

'use strict';
import './app.css';
import _ from 'lodash';
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import ZUtils   from 'zcontrol/lib/utils';
// import injectTapEventPlugin from 'react-tap-event-plugin';
import darkBaseTheme        from 'material-ui/styles/baseThemes/darkBaseTheme';
import MuiThemeProvider     from 'material-ui/styles/MuiThemeProvider';
import getMuiTheme          from 'material-ui/styles/getMuiTheme';
import Controls from 'zcontrol';
import THREE from 'three';

// injectTapEventPlugin();

import Com from './../components/FlyingLines';
import EarthChicken from './../components/EarthChicken';
import flyingData from '../data/flyingline.json';


//
const  comName = 'Globe';

// import zfilter from 'zfilter';

const options    = Com.defaultProps.options;
const validation = ZUtils.toValidation(options);

const lat = d => d.lat;
const lng = d => d.lng;
const id  = d => d._id;
let dataFilter = (ds) => ds;

const onChange = (options) => {
  draw(mockData, options);
};

// const onSelectChange = (filter) => {
//  dataFilter = zfilter.generate(filter);
//  mockData = mockData.map((d) => {
//    d.lat = parseFloat(d.lat, 10);
//    d.lng = parseFloat(d.lng, 10);
//    return d;
//  })
//  draw(mockData, options, dataFilter);
// };

const response = {
    errorCode: null,
    errMsg: null,
    data: [{
        date: 1504195200000,
        farm: [{
            code: 341225,
            stage: 2,
            parentCode: 340000,
            name: "舒城县",
            lati: 31.429016,
            loni: 117.053417,
            type: 1
        },
        {
            code: 130104,
            stage: 1,
            parentCode: 130000,
            name: "正安县",
            lati: 28.563442,
            loni: 107.492533,
            type: 1
        },
        {
            code: 420202,
            stage: 1,
            parentCode: 420000,
            name: "伊川县",
            lati: 34.424071,
            loni: 112.3061,
            type: 1
        },
        {
            code: 140302,
            stage: 1,
            parentCode: 140000,
            name: "叙永县",
            lati: 28.163532,
            loni: 105.503728,
            type: 1
        },
        {
            code: 340121,
            stage: 1,
            parentCode: 340000,
            name: "长丰县",
            lati: 31.60660972,
            loni: 117.65258789,
            type: 1
        }]
    },
    {
        date: 1498838400000,
        farm: [{
            code: 420202,
            stage: 1,
            parentCode: 420000,
            name: "伊川县",
            lati: 34.424071,
            loni: 112.3061,
            type: 1
        },
        {
            code: 140302,
            stage: 1,
            parentCode: 140000,
            name: "叙永县",
            lati: 28.163532,
            loni: 105.503728,
            type: 1
        },
        {
            code: 340121,
            stage: 1,
            parentCode: 340000,
            name: "长丰县",
            lati: 31.60660972,
            loni: 117.65258789,
            type: 1
        }]
    }],
    success: true
};

const styleMap = {
  width: '100%',
  height: '100%',
  left: '0',
  top: '0',
  position: 'absolute'
};
//<Bound options={options || {}} onChange={onSelectChange}/>
const draw = (Component, options, filter) => {
  // data = filter(data || []);
  ReactDOM.render(
    <Component />,
    document.querySelector('.main')
  );
};

export default class Root extends Component {
  constructor(props, context) {
    super(props, context);
    this.state = {
      isTesting: false
    }
  }

  onChange = () => {
    this.setState({
      isTesting: true,
    });
  }

  render() {
    const { isTesting } = this.state;
    let farms = [];
    if (isTesting) {
      farms = response.data[1].farm;
    } else {
      farms = response.data[0].farm;
    }
    return (
      <MuiThemeProvider muiTheme={getMuiTheme(darkBaseTheme)}>
        <div className="container all">
          <div className="control">
             <Controls 
               offset={{x:0, y:0}} 
               data={validation} 
               onChange={this.onChange}
               editale={false}
              />
           </div>
           <div className="app">
              <EarthChicken
                data={farms}
                style={styleMap}
              />
           </div>
         </div>
      </MuiThemeProvider>
    )
  }
}

draw(Root);

// fetch(`./data/flyingline.json`)
// .then(d => d.json())
// .then(ds => {
//   mockData = ds;
//   draw(ds);
// });
// redraw();

// setTimeout(() => {
//  ReactDOM.render(
//     <Map options={mapO}>
//     </Map>,
//   document.querySelector('.app')
// );
// }, 3000)
