/*
* @Author: zhouningyi
* @Date:   2017-01-01 15:51:11
* @Last Modified by:   zhouningyi
* @Last Modified time: 2017-07-28 01:28:28
*/

'use strict';
import './app.css';
import _ from 'lodash';
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import ZUtils   from 'zcontrol/lib/utils';
import injectTapEventPlugin from 'react-tap-event-plugin';

injectTapEventPlugin();
// import injectTapEventPlugin from 'react-tap-event-plugin';
import darkBaseTheme        from 'material-ui/styles/baseThemes/darkBaseTheme';
import MuiThemeProvider     from 'material-ui/styles/MuiThemeProvider';
import getMuiTheme          from 'material-ui/styles/getMuiTheme';
import Controls from 'zcontrol';
import THREE from 'three';

// injectTapEventPlugin();

import Com from './../components/FlyingLines';
import EarthChicken from './../components/EarthChicken';
import flyingData from '../data/flyingline.json';


//
const  comName = 'Globe';

// import zfilter from 'zfilter';

const options    = Com.defaultProps.options;
const validation = ZUtils.toValidation(options);

const lat = d => d.lat;
const lng = d => d.lng;
const id  = d => d._id;
let dataFilter = (ds) => ds;

const onChange = (options) => {
  draw(mockData, options);
};

// const onSelectChange = (filter) => {
//  dataFilter = zfilter.generate(filter);
//  mockData = mockData.map((d) => {
//    d.lat = parseFloat(d.lat, 10);
//    d.lng = parseFloat(d.lng, 10);
//    return d;
//  })
//  draw(mockData, options, dataFilter);
// };

const response = {
errorCode: null,
errMsg: null,
data: [
{
date: 1504195200000,
farm: [
{
code: 341225,
stage: 2,
provinceCode: 340000,
name: "阜南县",
lati: 32.655881,
provinceName: "安徽省",
loni: 115.654099,
type: 1,
color: '#00FF7F'
},
{
code: 130104,
stage: 1,
provinceCode: 130000,
name: "桥西区",
lati: 38.033365,
provinceName: "河北省",
loni: 114.43814,
type: 1,
color: '#4B0082'
},
{
code: 320324,
stage: 1,
provinceCode: 320000,
name: "睢宁县",
lati: 33.946571,
provinceName: "江苏省",
loni: 117.890364,
type: 1,
color: '#4B0082'
},
{
code: 420202,
stage: 1,
provinceCode: 420000,
name: "黄石港区",
lati: 30.233765,
provinceName: "湖北省",
loni: 115.073159,
type: 1,
color: '#4B0082'
},
{
code: 140302,
stage: 1,
provinceCode: 140000,
name: "阳泉市",
lati: 37.857865,
provinceName: "山西省",
loni: 113.612838,
type: 1,
color: '#4B0082'
}
]
},
{
date: 1501516800000,
farm: [
{
code: 320324,
stage: 1,
provinceCode: 320000,
name: "睢宁县",
lati: 33.946571,
provinceName: "江苏省",
loni: 117.890364,
type: 1,
color: '#EEEE00'
},
{
code: 420202,
stage: 1,
provinceCode: 420000,
name: "黄石港区",
lati: 30.233765,
provinceName: "湖北省",
loni: 115.073159,
type: 1,
color: '#EEEE00'
},
{
code: 140302,
stage: 1,
provinceCode: 140000,
name: "阳泉市",
lati: 37.857865,
provinceName: "山西省",
loni: 113.612838,
type: 1,
color: '#EEEE00'
}
]
},
{
date: 1498838400000,
farm: [
{
code: 420202,
stage: 1,
provinceCode: 420000,
name: "黄石港区",
lati: 30.233765,
provinceName: "湖北省",
loni: 115.073159,
type: 1,
color: '#FFFF00'
},
{
code: 140302,
stage: 1,
provinceCode: 140000,
name: "阳泉市",
lati: 37.857865,
provinceName: "山西省",
loni: 113.612838,
type: 1,
color: '#FFFF00'
}
]
}
],
success: true
}

const styleMap = {
  width: '100%',
  height: '100%',
  left: '0',
  top: '0',
  position: 'absolute'
};
//<Bound options={options || {}} onChange={onSelectChange}/>
const draw = (Component, options, filter) => {
  // data = filter(data || []);
  ReactDOM.render(
    <Component />,
    document.querySelector('.main')
  );
};

export default class Root extends Component {
  constructor(props, context) {
    super(props, context);
    this.state = {
      isTesting: false,
      mode: 0
    }
  }

  onChange = () => {
    const isTesting = this.state.isTesting;
    this.setState({
      isTesting: !isTesting,
    }, () => {
      console.log(this.state.isTesting);
    });
  }

  render() {
    const { isTesting, mode } = this.state;
    let farms = [];
    if (isTesting) {
      farms = response.data[1].farm;
    } else {
      farms = response.data[0].farm;
    }
    return (
      <MuiThemeProvider muiTheme={getMuiTheme(darkBaseTheme)}>
        <div className="container all">
          <div className="control">
             <Controls 
               offset={{x:0, y:0}} 
               data={validation} 
               onChange={this.onChange}
               editale={false}
              />
           </div>
           <div className="app">
              <EarthChicken
                mode={mode}
                data={farms}
                style={styleMap}
              />
           </div>
         </div>
      </MuiThemeProvider>
    )
  }
}

draw(Root);

// fetch(`./data/flyingline.json`)
// .then(d => d.json())
// .then(ds => {
//   mockData = ds;
//   draw(ds);
// });
// redraw();

// setTimeout(() => {
//  ReactDOM.render(
//     <Map options={mapO}>
//     </Map>,
//   document.querySelector('.app')
// );
// }, 3000)
